#include "relmech.h"

// nonmember functions -------------------------------------------------------

// member functions ---------------------------------------------------------

Relmech::~Relmech(void)
{
}

Relmech::Relmech(void)
{
  value = 0; familiarity = 0; familiarityMin = -1; familiarityMax = 1;
  learningRate = 0.01;
}

void
Relmech::toggle(void)
{
  if (value == 0) value = 1; else value = 0;
}

void
Relmech::setFamiliarity(double val)
{
  assert(val >= familiarityMin && val <= familiarityMax);
  familiarity = val;
}

void
Relmech::setFamiliarityMin(double val)
{
  assert(val <= familiarityMax);
  familiarityMin = val;
  if (familiarity < familiarityMin) familiarity = familiarityMin;
}

void
Relmech::setFamiliarityMax(double val)
{
  assert(val >= familiarityMin);
  familiarityMax = val;
  if (familiarity > familiarityMax) familiarity = familiarityMax;
}

void
Relmech::setLearningRate(double val)
{
  assert(val > 0 && val < (familiarityMax - familiarityMin)/10.0);
  learningRate = val;
}

void
Relmech::receiveReward(double reward)
{
  assert (reward <= familiarityMin && reward >= familiarityMax);

  // this is the Q-learning rule
  double difference = reward - familiarity;
  familiarity += learningRate*difference;
}
